package tech.nevets.vcardgen;

import com.google.gson.Gson;
import com.google.gson.JsonObject;

import javax.servlet.MultipartConfigElement;
import java.io.*;

import static spark.Spark.*;

public class Main {
    public static void main(String[] args) {
        Location.loadLocations();

        port(8080);
        path("/backend", () -> {
            before("/*");

            get("/heartbeat", (req, res) -> {
                res.status(200);
                res.type("application/json");
                res.header("Access-Control-Allow-Origin", "*");
                return "{ \"up\":true }";
            });

            get("/data/locations", (req, res) -> {
                res.status(200);
                res.type("application/json");
                res.header("Access-Control-Allow-Origin", "*");
                return new FileInputStream("locations.json");
            });

            post("/generate", (req, res) -> {
                res.type("image/png");
                res.header("Access-Control-Allow-Origin", "*");
                JsonObject data = new Gson().fromJson(req.body(), JsonObject.class);
                return new VCard(data).toByteArray();
            });

            post("/edit", (req, res) -> {
                req.attribute("org.eclipse.jetty.multipartConfig", new MultipartConfigElement("/temp"));
                res.status(200);
                res.type("application/json");
                res.header("Access-Control-Allow-Origin", "*");
                return VCard.getDataFromVCard(req.raw().getPart("card").getInputStream());
            });
        });
    }
}
